from requests import get
from bs4 import BeautifulSoup
from chardet import detect
import csv
from json import dumps
# Dummy
ROOT = "http://192.168.2.20"

def bundle_file(url:str):
  # get the file
  raw = get(url).content
  encoding = detect(raw)['encoding']
  raw = raw.decode(encoding)

  # turn it into json
  reader = csv.DictReader(raw)
  for row in reader:
    for key in row:
      row[key] = row[key].strip()
  arr.append(row)
  
  # dump to file
  with open("out.json", "w") as f:
    f.write(dumps(arr, indent=2))
  
  return arr
  
  
  
def get_file(entries:int):
  url = f"{ROOT}/Portal/Portal.mwsl?PriNav=DataLog&RecentCount={entries}"
  soup = BeautifulSoup(get(url).content, "html.parser")
  link = soup.find(id="link1")
  
  return bundle_file(ROOT + link['href'])
  

def main():
  file = get_file(10)
  print(file)

if __name__ == "__main__":
  main()